﻿/* In your visual studio project, add reference to the following:
 * 
 * PresentationCore
 * PresentationFramework
 * System.Windows
 * System.Windows.Forms
 * System.Xaml
 * WindowsBase
 * Winterbuddy.exe
 */

using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using Nyx.Utilities;
using Nyx.Utilities.Plugins;

namespace SamplePlugin
{
    public class SamplePlugin : IPlugin
    {
        private static Version PLUGIN_VERSION = new Version(1, 0, 0);
        private const string PLUGIN_NAME = "SamplePlugin";
        private const string PLUGIN_AUTHOR = "YOUR_NAME_HERE";
        private const string PLUGIN_DESCRIPTION = "";

        /// <summary>
        /// The Plugin Author
        /// </summary>
        public string Author
        {
            get { return PLUGIN_AUTHOR; }
        }

        /// <summary>
        /// The plugin Description
        /// </summary>
        public string Description
        {
            get { return PLUGIN_DESCRIPTION; }
        }

        /// <summary>
        /// The configuration window
        /// </summary>
        public System.Windows.Window DisplayWindow
        {
            get { return null; }
        }

        /// <summary>
        /// The name of the plugin
        /// </summary>
        public string Name
        {
            get { return PLUGIN_NAME; }
        }

        /// <summary>
        /// OnDisabled is called when the plugin is Disabled
        /// </summary>
        public void OnDisabled()
        {
            // do on-disabled stuff

            Logging.Write(string.Format("Plugin {0} Version {1} by {2} Disabled", PLUGIN_NAME, PLUGIN_VERSION, PLUGIN_AUTHOR));
        }

        /// <summary>
        /// OnEnabled is called when the plugin is Enabled
        /// </summary>
        public void OnEnabled()
        {
            // do on-enabled stuff

            Logging.Write(string.Format("Plugin {0} Version {1} by {2} Enabled", PLUGIN_NAME, PLUGIN_VERSION, PLUGIN_AUTHOR));
        }

        /// <summary>
        /// OnInitialize is called once, when the Plugin Initializes
        /// </summary>
        public void OnInitialize()
        {
            // do initialization stuff

            Logging.Write(string.Format("Plugin {0} Version {1} by {2} Initialized", PLUGIN_NAME, PLUGIN_VERSION, PLUGIN_AUTHOR));
        }

        /// <summary>
        /// OnPulse is called every "tick"
        /// </summary>
        public void OnPulse()
        {

        }

        /// <summary>
        /// Called when Winterbuddy is shutting-down
        /// </summary>
        public void OnShutdown()
        {

        }

        /// <summary>
        /// The plugin Version
        /// </summary>
        public Version Version
        {
            get { return PLUGIN_VERSION;  }
        }

        /// <summary>
        /// IEquatable implementation
        /// </summary>
        /// <param name="other"></param>
        /// <returns></returns>
        public bool Equals(IPlugin other)
        {
            return this.Name == other.Name;
        }
    }
}
